/*
 * swmod_opkg.h: SWMOD deamon
 *
 * Copyright (C) 2020 iopsys Software Solutions AB. All rights reserved.
 *
 * Author: Amin Ben Ramdhane <amin.benramdhane@pivasoftware.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */

#ifndef __SWMOD_OPKG_H
#define __SWMOD_OPKG_H

#include "swmod.h"
#include "swmod_uci.h"
#include "swmod_common.h"

#define DW_DIR_PATH "/tmp/swmodd_dw"
#define DW_PKG_MOUNT_PATH DW_DIR_PATH"/dw_package.ipk"
#define DW_PKG_LOCAL_PATH "tmp/dw_package.ipk"

enum swmod_opkg_action_enum {
	SWMOD_INSTALL,
	SWMOD_UPDATE,
	SWMOD_REMOVE
};

int swmod_perform_installation(const char *url, const char *uname, const char *pwd, char *output, int out_len);
int swmod_perform_upgrade(const char *url, const char *uname, const char *pwd, char *output, int out_len);
int swmod_perform_uninstall(const char *pname, char *output, int out_len);
void populate_opkg_deployment_unit(ExecEnv_t *ee, struct list_head *pkg_list);
bool is_compulsory_service(const char *service);
bool is_opkg_service(char *info);
int download_remote_package(const char *url, const char *username, const char *password, const char *dst);

#endif //__SWMOD_OPKG_H
